function [v] = checkSubMatrix(A)
% check that A is a 3 x 3 matrix
% check that A contains all numbers between 1 and 9
% do it linearly via using an auxiliary array 
% initialized all to zeros
met=zeros(9);

sz = size(A);

if(sz(1) ~= 3 || sz(2) ~= 3 )
    disp('bad size');
    v = false;
    return;
end    

for i=1:3
    for j = 1:3
        disp ([i j A(i,j) met(A(i,i))]);
        if (met(A(i,j)) ~= 0) 
            v=false;
            return;
        end
        met(A(i,j))=1;
    end
end;
v=true;