
%generate 9 x 9 matrix with values between 1 and 9. 

% good
A = [ 5 3 4 6 7 8 9 1 2;
      6 7 2 1 9 5 3 4 8;
      1 9 8 3 4 2 5 6 7;
      8 5 9 7 6 1 4 2 3;
      4 2 6 8 5 3 7 9 1;
      7 1 3 9 2 4 8 5 6;
      9 6 1 5 3 7 2 8 4;
      2 8 7 4 1 9 6 3 5;
      3 4 5 2 8 6 1 7 9];
%bad row  
%A = [ 5 3 4 6 7 8 9 1 5;
%      6 7 2 1 9 5 3 4 8;
%      1 9 8 3 4 2 5 6 7;
%      8 5 9 7 6 1 4 2 3;
%      4 2 6 8 5 3 7 9 1;
%      7 1 3 9 2 4 8 5 6;
%      9 6 1 5 3 7 2 8 4;
%      2 8 7 4 1 9 6 3 5;
%      3 4 5 2 8 6 1 7 9];


%bad column
A = [ 5 3 4 6 7 8 9 1 2;
      6 7 2 1 9 5 3 4 8;
      1 9 8 3 4 2 5 6 7;
      8 5 9 7 6 1 4 2 3;
      4 2 6 8 5 3 7 9 1;
      7 1 3 9 2 4 8 5 6;
      9 6 1 5 3 7 2 8 4;
      2 8 7 4 1 9 6 3 5;
      5 4 5 2 8 6 1 7 9];

  
disp(A);
% check rows and columns
for i=1:9
    % check row
    v = checkVector(A(i,:));
    if (v == false) 
       disp('row: bad matrix');
        return
    end;
    
    %check column
    v = checkVector(A(:,i));
    if (v == false) 
        disp('col: bad matrix');
        return
    end;
end

%check submatrices
for i=1:3:7
    for j = 1:3:7
        B = A(i:i+2,j:j+2);
        v = checkSubMatrix(B);
        if (v == false)
            disp( [ i j ]);
            disp ('sub: bad matrix');
            return;
        end
    end
end

%no problem, then it is a solution
disp ('good matrix');